import os
import subprocess
import sys
import squish_py_util

from multiprocessing.managers import BaseManager

remote_port = 8989
remote_password = "MeineGeheimesPassword"

def start_server( port, password ):
    print "Listening for incoming connections..."
    mgr = BaseManager( address=( '', port ), authkey=password )
    s = mgr.get_server()
    s.serve_forever()

def get_file( file_name ):
    print "File requested: %s" % file_name

    if not os.path.exists( file_name ):
        return ( None, "REMOTE SERVER ERROR: File does not exist: %s" % file_name )

    if os.path.isdir( file_name ):
        return ( None, "REMOTE SERVER ERROR: Path to file expected, but path is a folder: %s" % file_name )

    try:
        f = open( file_name, "rb" )
        c = f.read()
        f.close()
        return ( c, None )
    except Exception as e:
        return ( None, "REMOTE SERVER ERROR: Opening/reading file failed: %s: %s" % ( file_name, e ) )
 
def put_file( file_name, file_contents ):
    try:
        f = open( file_name, "wb" )
        f.write( file_contents )
        f.close()
        return None
    except Exception as e:
        return "REMOTE SERVER ERROR: Opening/writing file failed: %s: %s" % ( file_name, e )

if __name__ == "__main__":
    if "SQUISH_PREFIX" in os.environ:
        squishpyutil.remove_squish_paths_and_run_again( os.environ[ "SQUISH_PREFIX" ] )
    elif len( sys.argv ) == 1:
        BaseManager.register( "get_file", get_file )
        BaseManager.register( "put_file", put_file )
        start_server( remote_port, remote_password )
    else:
        print "USAGE: python %s" % sys.argv[ 0 ]
